﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Compression;
using System.IO;

namespace CompressionLibUsingStreams
{
    public partial class MainPage : UserControl
    {
        FileStream _loadArchiveInputStream;
        ZipFile _zip;

        public MainPage()
        {
            InitializeComponent();
        }

        private void btnLoad_Click(object sender, RoutedEventArgs e)
        {
            this.CloseUsedStream();

            OpenFileDialog ofd = new OpenFileDialog();
            var result = ofd.ShowDialog();

            if (result.HasValue && result == true)
            {
                this._loadArchiveInputStream = ofd.File.OpenRead();
                _zip = new ZipFile(_loadArchiveInputStream);

                entries.Items.Clear();
                foreach (var entry in _zip.Entries)
                    entries.Items.Add(entry.FileName);
            }
        }

        private void btnNew_Click(object sender, RoutedEventArgs e)
        {
            this.CloseUsedStream();
            this._zip = new ZipFile();
            entries.Items.Clear();
        }

        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();

            var result = sfd.ShowDialog();
            if (result.HasValue && result == true)
                using (var fs = sfd.OpenFile())
                    _zip.Save(fs);
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            var result = ofd.ShowDialog();

            if (result.HasValue && result == true)
            {
                var fs = ofd.File.OpenRead();
                _zip.Entries.Add(ZipEntry.CreateFile(ofd.File.Name, "/", fs));

                entries.Items.Add(ofd.File.Name);
            }
        }

        private void CloseUsedStream()
        {
            if (this._loadArchiveInputStream != null)
                this._loadArchiveInputStream.Close();

            if (this._zip != null)
                foreach (var entry in this._zip.Entries)
                    if (entry.InputStream != null)
                        entry.InputStream.Close();
        }
    }
}
